Index: palm/trunk/SOURCE/CURRENT_MODIFICATIONS
===================================================================
--- palm/trunk/SOURCE/CURRENT_MODIFICATIONS	(revision 142)
+++ palm/trunk/SOURCE/CURRENT_MODIFICATIONS	(revision 143)
@@ -1,19 +1,42 @@
 New:
 ---
+Within a job chain, the number of processors or the virtual processor grid
+is now allowed to be changed. This modifies the domain decomposition and
+requires that the PEs within a restart job have to know from which file(s) they
+have to read their restart data (up to now there is a one to one relation
+between the restart files and the PEs, i.e. processor 4 only reads data
+from file "_0004"). Informations about the subdomain index limits of all
+restart files are now written by PE0 (to file "_0000"). Also, all variables
+containing global values which do not depend on the subdomain are written
+to file "_0000" only. In a restart run, this file is opened by all PEs to
+read these global values and the informations about the subdomain index
+limits. Depending on these index limit information it is decided which
+restart file(s) has/have to be opened in order to read the complete data
+necessary for the current subdomain.
 
+check_open, read_var_list, read_3d_binary, write_3d_binary
 
 
 Changed:
 -------
+-cross_ts_* (read_var_list, write_var_list)
+-dopr_time_count, old profil parameters (cross_..., dopr_crossindex,
+ profile_***) removed (read_3d_binary, write_3d_binary)
 
+hom_sum moved, volume_flow_area, volume_flow_initial moved from ..._3d_binary
+to ..._var_list, hom_sum is now allocated in parin instead of init_3d_model
+
+init_3d_model, parin, read_var_list, read_3d_binary, write_var_list, write_3d_binary
 
 
 Errors:
 ------
+Bugfix: remove IF statement in plant_canopy_model_ij (plant_canopy_model)
+Bugfix: divide sums(k,8) (e) and sums(k,34) (e*) by ngp_2dh_s_inner(k,sr) 
+(like other scalars) (flow_statistics)
+Bugfix: dopr_time_count was written on the binary file, which caused that
+NetCDF files newly created by restart files (no append of existing files!)
+contained uneccessary time levels. (read_3d_binary, write_3d_binary)
 
-Bugfix: remove IF statement in plant_canopy_model_ij
-Bugfix: divide sums(k,8) (e) and sums(k,34) (e*) by ngp_2dh_s_inner(k,sr) 
-(like other scalars)
+flow_statistics, plant_canopy_model, read_3d_binary, write_3d_binary
 
-flow_statistics, plant_canopy_model
-
Index: palm/trunk/SOURCE/check_open.f90
===================================================================
--- palm/trunk/SOURCE/check_open.f90	(revision 142)
+++ palm/trunk/SOURCE/check_open.f90	(revision 143)
@@ -4,5 +4,6 @@
 ! Actual revisions:
 ! -----------------
-! 
+! First opening of unit 13 openes file _0000 on all PEs (parallel version)
+! because only this file contains the global variables
 !
 ! Former revisions:
@@ -92,10 +93,10 @@
     IF ( openfile(file_id)%opened_before )  THEN
        SELECT CASE ( file_id )
-          CASE ( 14, 21, 22, 23, 80:85 )
+          CASE ( 13, 14, 21, 22, 23, 80:85 )
              IF ( file_id == 14 .AND. openfile(file_id)%opened_before )  THEN
                 IF ( myid == 0 )  PRINT*, '+++ check_open: re-open of unit ', &
                                    ' 14 is not verified. Please check results!'
              ENDIF
-             CONTINUE
+
           CASE DEFAULT
              IF ( myid == 0 )  THEN
@@ -104,4 +105,5 @@
              ENDIF
              RETURN
+
        END SELECT
     ENDIF
@@ -162,6 +164,14 @@
                         FORM='UNFORMATTED', STATUS='OLD' )
           ELSE
-             OPEN ( 13, FILE='BININ'//TRIM( coupling_char )//'/'//myid_char, &
-                        FORM='UNFORMATTED', STATUS='OLD' )
+!
+!--          First opening of unit 13 openes file _0000 on all PEs because only
+!--          this file contains the global variables
+             IF ( .NOT. openfile(file_id)%opened_before )  THEN
+                OPEN ( 13, FILE='BININ'//TRIM( coupling_char )//'/_0000',&
+                           FORM='UNFORMATTED', STATUS='OLD' )
+             ELSE
+                OPEN ( 13, FILE='BININ'//TRIM( coupling_char )//'/'//myid_char,&
+                           FORM='UNFORMATTED', STATUS='OLD' )
+             ENDIF
           ENDIF
 
Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 142)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 143)
@@ -7,5 +7,5 @@
 ! Actual revisions:
 ! -----------------
-! 
+! Allocation of hom_sum moved to parin
 !
 ! Former revisions:
@@ -101,6 +101,5 @@
               sums_divold_l(0:statistic_regions) )
     ALLOCATE( rdf(nzb+1:nzt) )
-    ALLOCATE( hom_sum(nzb:nzt+1,pr_palm+max_pr_user,0:statistic_regions),   &
-              ngp_2dh_outer(nzb:nzt+1,0:statistic_regions),                 &
+    ALLOCATE( ngp_2dh_outer(nzb:nzt+1,0:statistic_regions),                 &
               ngp_2dh_outer_l(nzb:nzt+1,0:statistic_regions),               &
               ngp_2dh_s_inner(nzb:nzt+1,0:statistic_regions),               &
Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 142)
+++ palm/trunk/SOURCE/parin.f90	(revision 143)
@@ -4,5 +4,5 @@
 ! Actual revisions:
 ! -----------------
-! 
+! Allocation of hom_sum moved from init_3d_model to here
 !
 ! Former revisions:
@@ -243,7 +243,8 @@
 
        ALLOCATE( ug(0:nz+1), vg(0:nz+1), &
-                 pt_init(0:nz+1), q_init(0:nz+1), sa_init(0:nz+1), &
-                 u_init(0:nz+1), v_init(0:nz+1),                   &
-                 hom(0:nz+1,2,pr_palm+max_pr_user,0:statistic_regions) )
+                 pt_init(0:nz+1), q_init(0:nz+1), sa_init(0:nz+1),          &
+                 u_init(0:nz+1), v_init(0:nz+1),                            &
+                 hom(0:nz+1,2,pr_palm+max_pr_user,0:statistic_regions),     &
+                 hom_sum(nzb:nzt+1,pr_palm+max_pr_user,0:statistic_regions) )
        hom = 0.0
 
Index: palm/trunk/SOURCE/read_3d_binary.f90
===================================================================
--- palm/trunk/SOURCE/read_3d_binary.f90	(revision 142)
+++ palm/trunk/SOURCE/read_3d_binary.f90	(revision 143)
@@ -4,5 +4,9 @@
 ! Actual revisions:
 ! -----------------
-! 
+! Restart file has to be re-opened on all PEs except PE0
+! -dopr_time_count,
+! hom_sum moved, volume_flow_area, volume_flow_initial moved to read_var_list,
+! reading of old profil parameters (cross_..., dopr_crossindex, profile_***)
+! removed
 !
 ! Former revisions:
@@ -54,18 +58,15 @@
     CHARACTER (LEN=10) ::  binary_version, version_on_file
     CHARACTER (LEN=20) ::  field_chr
-    CHARACTER (LEN=10),  DIMENSION(:), ALLOCATABLE ::  chdum10
-    CHARACTER (LEN=40),  DIMENSION(:), ALLOCATABLE ::  chdum40
-    CHARACTER (LEN=100), DIMENSION(:), ALLOCATABLE ::  chdum100
 
     INTEGER ::  idum1, myid_on_file, numprocs_on_file, nxl_on_file, &
                 nxr_on_file, nyn_on_file, nys_on_file, nzb_on_file, nzt_on_file
 
-    INTEGER, DIMENSION(:), ALLOCATABLE ::  idum
-
-    REAL, DIMENSION(:), ALLOCATABLE ::  rdum
-
 !
 !-- Read data from previous model run. unit 13 already opened in parin
     CALL cpu_log( log_point_s(14), 'read_3d_binary', 'start' )
+
+!
+!-- Restart file has to be re-opened on all PEs except PE0
+    CALL check_open( 13 )
 
 !
@@ -173,10 +174,4 @@
        CALL local_stop
     ENDIF
-
-!
-!-- Local arrays that may be required for possible temporary information 
-!-- storage in the following
-    ALLOCATE( chdum10(crmax), chdum40(crmax), chdum100(crmax), &
-              idum(100*crmax), rdum(100*crmax) )
 
 !
@@ -304,8 +299,4 @@
           CASE ( 'shf_m' )
              READ ( 13 )  shf_m
-          CASE ( 'tswst' )
-             READ ( 13 )  tswst
-          CASE ( 'tswst_m' )
-             READ ( 13 )  tswst_m
           CASE ( 'spectrum_x' )
              READ ( 13 )  spectrum_x
@@ -317,4 +308,8 @@
              ALLOCATE( ts_av(nys-1:nyn+1,nxl-1:nxr+1) )
              READ ( 13 )  ts_av
+          CASE ( 'tswst' )
+             READ ( 13 )  tswst
+          CASE ( 'tswst_m' )
+             READ ( 13 )  tswst_m
           CASE ( 'u' )
              READ ( 13 )  u
@@ -347,8 +342,4 @@
           CASE ( 'v' )
              READ ( 13 )  v
-          CASE ( 'volume_flow_area' )
-             READ ( 13 )  volume_flow_area
-          CASE ( 'volume_flow_initial' )
-             READ ( 13 )  volume_flow_initial
           CASE ( 'v_av' )
              ALLOCATE( v_av(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
@@ -400,157 +391,4 @@
              READ ( 13 )  z0_av
 
-          CASE ( 'cross_linecolors' )
-             IF ( use_prior_plot1d_parameters )  THEN
-                READ ( 13 )  cross_linecolors
-             ELSE
-                READ ( 13 )  idum
-             ENDIF
-          CASE ( 'cross_linestyles' )
-             IF ( use_prior_plot1d_parameters )  THEN
-                READ ( 13 )  cross_linestyles
-             ELSE
-                READ ( 13 )  idum
-             ENDIF
-          CASE ( 'cross_normalized_x' )
-             IF ( use_prior_plot1d_parameters )  THEN
-                READ ( 13 )  cross_normalized_x
-             ELSE
-                READ ( 13 )  chdum10
-             ENDIF
-          CASE ( 'cross_normalized_y' )
-             IF ( use_prior_plot1d_parameters )  THEN
-                READ ( 13 )  cross_normalized_y
-             ELSE
-                READ ( 13 )  chdum10
-             ENDIF
-          CASE ( 'cross_normx_factor' )
-             IF ( use_prior_plot1d_parameters )  THEN
-                READ ( 13 )  cross_normx_factor
-             ELSE
-                READ ( 13 )  rdum
-             ENDIF
-          CASE ( 'cross_normy_factor' )
-             IF ( use_prior_plot1d_parameters )  THEN
-                READ ( 13 )  cross_normy_factor
-             ELSE
-                READ ( 13 )  rdum
-             ENDIF
-          CASE ( 'cross_profiles' )
-             IF ( use_prior_plot1d_parameters )  THEN
-                READ ( 13 )  cross_profiles
-             ELSE
-                READ ( 13 )  chdum100
-             ENDIF
-          CASE ( 'cross_profile_n_coun' )
-             IF ( use_prior_plot1d_parameters )  THEN
-                READ ( 13 )  cross_profile_number_count
-             ELSE
-                READ ( 13 )  idum(1:crmax)
-             ENDIF
-          CASE ( 'cross_profile_number' )
-             IF ( use_prior_plot1d_parameters )  THEN
-                READ ( 13 )  cross_profile_numbers
-             ELSE
-                READ ( 13 )  idum
-             ENDIF
-          CASE ( 'cross_uxmax' )
-             IF ( use_prior_plot1d_parameters )  THEN
-                READ ( 13 )  cross_uxmax
-             ELSE
-                READ ( 13 )  rdum(1:crmax)
-             ENDIF
-          CASE ( 'cross_uxmax_computed' )
-             IF ( use_prior_plot1d_parameters )  THEN
-                READ ( 13 )  cross_uxmax_computed
-             ELSE
-                READ ( 13 )  rdum(1:crmax)
-             ENDIF
-          CASE ( 'cross_uxmax_normaliz' )
-             IF ( use_prior_plot1d_parameters )  THEN
-                READ ( 13 )  cross_uxmax_normalized
-             ELSE
-                READ ( 13 )  rdum(1:crmax)
-             ENDIF
-          CASE ( 'cross_uxmax_norm_com' )
-             IF ( use_prior_plot1d_parameters )  THEN
-                READ ( 13 )  cross_uxmax_normalized_computed
-             ELSE
-                READ ( 13 )  rdum(1:crmax)
-             ENDIF
-          CASE ( 'cross_uxmin' )
-             IF ( use_prior_plot1d_parameters )  THEN
-                READ ( 13 )  cross_uxmin
-             ELSE
-                READ ( 13 )  rdum(1:crmax)
-             ENDIF
-          CASE ( 'cross_uxmin_computed' )
-             IF ( use_prior_plot1d_parameters )  THEN
-                READ ( 13 )  cross_uxmin_computed
-             ELSE
-                READ ( 13 )  rdum(1:crmax)
-             ENDIF
-          CASE ( 'cross_uxmin_normaliz' )
-             IF ( use_prior_plot1d_parameters )  THEN
-                READ ( 13 )  cross_uxmin_normalized
-             ELSE
-                READ ( 13 )  rdum(1:crmax)
-             ENDIF
-          CASE ( 'cross_uxmin_norm_com' )
-             IF ( use_prior_plot1d_parameters )  THEN
-                READ ( 13 )  cross_uxmin_normalized_computed
-             ELSE
-                READ ( 13 )  rdum(1:crmax)
-             ENDIF
-          CASE ( 'cross_uymax' )
-             IF ( use_prior_plot1d_parameters )  THEN
-                READ ( 13 )  cross_uymax
-             ELSE
-                READ ( 13 )  rdum(1:crmax)
-             ENDIF
-          CASE ( 'cross_uymin' )
-             IF ( use_prior_plot1d_parameters )  THEN
-                READ ( 13 )  cross_uymin
-             ELSE
-                READ ( 13 )  rdum(1:crmax)
-             ENDIF
-          CASE ( 'cross_xtext' )
-             IF ( use_prior_plot1d_parameters )  THEN
-                READ ( 13 )  cross_xtext
-             ELSE
-                READ ( 13 )  chdum40
-             ENDIF
-          CASE ( 'dopr_crossindex' )
-             IF ( use_prior_plot1d_parameters )  THEN
-                READ ( 13 )  dopr_crossindex
-             ELSE
-                READ ( 13 )  idum(1:100)
-             ENDIF
-          CASE ( 'dopr_time_count' )
-             IF ( use_prior_plot1d_parameters )  THEN
-                READ ( 13 )  dopr_time_count
-             ELSE
-                READ ( 13 )  idum1
-             ENDIF
-          CASE ( 'hom_sum' )
-             READ ( 13 )  hom_sum
-          CASE ( 'profile_columns' )
-             IF ( use_prior_plot1d_parameters )  THEN
-                READ ( 13 )  profile_columns
-             ELSE
-                READ ( 13 )  idum1
-             ENDIF
-          CASE ( 'profile_number' )
-             IF ( use_prior_plot1d_parameters )  THEN
-                READ ( 13 )  profile_number
-             ELSE
-                READ ( 13 )  idum1
-             ENDIF
-          CASE ( 'profile_rows' )
-             IF ( use_prior_plot1d_parameters )  THEN
-                READ ( 13 )  profile_rows
-             ELSE
-                READ ( 13 )  idum1
-             ENDIF
-
           CASE DEFAULT
              PRINT*, '+++ init_3d_model: unknown field named "', &
@@ -566,6 +404,4 @@
     ENDDO
 
-    DEALLOCATE( chdum10, chdum40, chdum100, idum, rdum )
-
 !
 !-- End of time measuring for reading binary data
Index: palm/trunk/SOURCE/read_var_list.f90
===================================================================
--- palm/trunk/SOURCE/read_var_list.f90	(revision 142)
+++ palm/trunk/SOURCE/read_var_list.f90	(revision 143)
@@ -4,5 +4,8 @@
 ! Actual revisions:
 ! -----------------
-! 
+! After reading the global variables, unit 13 is closed for all PEs except PE0
+! -cross_ts_*,
+! hom_sum moved, volume_flow_area, volume_flow_initial moved from
+! read_3d_binary to here
 !
 ! Former revisions:
@@ -42,5 +45,5 @@
 ! Description:
 ! ------------
-! Reading values of control variables from restart-file (binary format)
+! Reading values of global control variables from restart-file (binary format)
 !------------------------------------------------------------------------------!
 
@@ -62,5 +65,6 @@
 
     INTEGER            ::  max_pr_user_on_file
-    
+
+
     CALL check_open( 13 )
 
@@ -245,4 +249,6 @@
           CASE ( 'hom' )
              READ ( 13 )  hom
+          CASE ( 'hom_sum' )
+             READ ( 13 )  hom_sum
           CASE ( 'inflow_disturbance_begin' )
              READ ( 13 )  inflow_disturbance_begin
@@ -485,4 +491,8 @@
           CASE ( 'vg_vertical_gradient_level_ind' )
              READ ( 13 )  vg_vertical_gradient_level_ind
+          CASE ( 'volume_flow_area' )
+             READ ( 13 )  volume_flow_area
+          CASE ( 'volume_flow_initial' )
+             READ ( 13 )  volume_flow_initial
           CASE ( 'wall_adjustment' )
              READ ( 13 )  wall_adjustment
@@ -491,7 +501,4 @@
           CASE ( 'w_max_ijk' )
              READ ( 13 )  w_max_ijk
-          CASE ( 'time-series-quantities' )
-             READ ( 13 )  cross_ts_uymax, cross_ts_uymax_computed, &
-                          cross_ts_uymin, cross_ts_uymin_computed
 
           CASE DEFAULT
@@ -507,4 +514,6 @@
     ENDDO
 
+    IF ( myid /= 0 )  CALL close_file( 13 )
+
 
  END SUBROUTINE read_var_list
Index: palm/trunk/SOURCE/write_3d_binary.f90
===================================================================
--- palm/trunk/SOURCE/write_3d_binary.f90	(revision 142)
+++ palm/trunk/SOURCE/write_3d_binary.f90	(revision 143)
@@ -4,5 +4,9 @@
 ! Actual revisions:
 ! -----------------
-! 
+! write_var_list is only called for pe0
+! -dopr_time_count,
+! hom_sum moved, volume_flow_area, volume_flow_initial moved to write_var_list,
+! writing of old profil parameters (cross_..., dopr_crossindex, profile_***)
+! removed
 !
 ! Former revisions:
@@ -61,5 +65,5 @@
 !
 !-- Write control parameters and other variables for restart.
-    CALL write_var_list
+    IF ( myid == 0 )  CALL write_var_list
 
 !
@@ -177,4 +181,8 @@
        WRITE ( 14 )  'shf_m               ';  WRITE ( 14 )  shf_m
     ENDIF
+    IF ( ALLOCATED( spectrum_x ) )  THEN
+       WRITE ( 14 )  'spectrum_x          ';  WRITE ( 14 )  spectrum_x
+       WRITE ( 14 )  'spectrum_y          ';  WRITE ( 14 )  spectrum_y
+    ENDIF
     WRITE ( 14 )  'ts                  ';  WRITE ( 14 )  ts
     IF ( ALLOCATED( ts_av ) )  THEN
@@ -213,6 +221,4 @@
     ENDIF
     WRITE ( 14 )  'v                   ';  WRITE ( 14 )  v
-    WRITE ( 14 )  'volume_flow_area    ';  WRITE ( 14 )  volume_flow_area
-    WRITE ( 14 )  'volume_flow_initial ';  WRITE ( 14 )  volume_flow_initial
     IF ( ALLOCATED( v_av ) )  THEN
        WRITE ( 14 )  'v_av                ';  WRITE ( 14 )  v_av
@@ -268,38 +274,4 @@
     ENDIF
 
-    WRITE ( 14 )  'cross_linecolors    ';  WRITE ( 14 )  cross_linecolors
-    WRITE ( 14 )  'cross_linestyles    ';  WRITE ( 14 )  cross_linestyles
-    WRITE ( 14 )  'cross_normalized_x  ';  WRITE ( 14 )  cross_normalized_x
-    WRITE ( 14 )  'cross_normalized_y  ';  WRITE ( 14 )  cross_normalized_y
-    WRITE ( 14 )  'cross_normx_factor  ';  WRITE ( 14 )  cross_normx_factor
-    WRITE ( 14 )  'cross_normy_factor  ';  WRITE ( 14 )  cross_normy_factor
-    WRITE ( 14 )  'cross_profiles      ';  WRITE ( 14 )  cross_profiles
-    WRITE ( 14 )  'cross_profile_n_coun'
-                  WRITE ( 14 )  cross_profile_number_count
-    WRITE ( 14 )  'cross_profile_number';  WRITE ( 14 )  cross_profile_numbers
-    WRITE ( 14 )  'cross_uxmax         ';  WRITE ( 14 )  cross_uxmax
-    WRITE ( 14 )  'cross_uxmax_computed';  WRITE ( 14 )  cross_uxmax_computed
-    WRITE ( 14 )  'cross_uxmax_normaliz';  WRITE ( 14 )  cross_uxmax_normalized
-    WRITE ( 14 )  'cross_uxmax_norm_com'
-                  WRITE ( 14 )  cross_uxmax_normalized_computed
-    WRITE ( 14 )  'cross_uxmin         ';  WRITE ( 14 )  cross_uxmin
-    WRITE ( 14 )  'cross_uxmin_computed';  WRITE ( 14 )  cross_uxmin_computed
-    WRITE ( 14 )  'cross_uxmin_normaliz';  WRITE ( 14 )  cross_uxmin_normalized
-    WRITE ( 14 )  'cross_uxmin_norm_com'
-                  WRITE ( 14 )  cross_uxmin_normalized_computed
-    WRITE ( 14 )  'cross_uymax         ';  WRITE ( 14 )  cross_uymax
-    WRITE ( 14 )  'cross_uymin         ';  WRITE ( 14 )  cross_uymin
-    WRITE ( 14 )  'cross_xtext         ';  WRITE ( 14 )  cross_xtext
-    WRITE ( 14 )  'dopr_crossindex     ';  WRITE ( 14 )  dopr_crossindex
-    WRITE ( 14 )  'dopr_time_count     ';  WRITE ( 14 )  dopr_time_count
-    WRITE ( 14 )  'hom_sum             ';  WRITE ( 14 )  hom_sum
-    WRITE ( 14 )  'profile_columns     ';  WRITE ( 14 )  profile_columns
-    WRITE ( 14 )  'profile_number      ';  WRITE ( 14 )  profile_number
-    WRITE ( 14 )  'profile_rows        ';  WRITE ( 14 )  profile_rows
-    IF ( ALLOCATED( spectrum_x ) )  THEN
-       WRITE ( 14 )  'spectrum_x          ';  WRITE ( 14 )  spectrum_x
-       WRITE ( 14 )  'spectrum_y          ';  WRITE ( 14 )  spectrum_y
-    ENDIF
-
 !
 !-- Write end label. Unit 14 is closed in the main program.
Index: palm/trunk/SOURCE/write_var_list.f90
===================================================================
--- palm/trunk/SOURCE/write_var_list.f90	(revision 142)
+++ palm/trunk/SOURCE/write_var_list.f90	(revision 143)
@@ -4,5 +4,7 @@
 ! Actual revisions:
 ! -----------------
-! 
+! -cross_ts_*,
+! hom_sum, volume_flow_area, volume_flow_initial moved from write_3d_binary
+! to here
 !
 ! Former revisions:
@@ -191,4 +193,6 @@
     WRITE ( 14 )  'hom                           '
     WRITE ( 14 )  hom
+    WRITE ( 14 )  'hom_sum                       '
+    WRITE ( 14 )  hom_sum
     WRITE ( 14 )  'inflow_disturbance_begin      '
     WRITE ( 14 )  inflow_disturbance_begin
@@ -431,4 +435,8 @@
     WRITE ( 14 )  'vg_vertical_gradient_level_ind'
     WRITE ( 14 )  vg_vertical_gradient_level_ind
+    WRITE ( 14 )  'volume_flow_area              '
+    WRITE ( 14 )  volume_flow_area
+    WRITE ( 14 )  'volume_flow_initial           '
+    WRITE ( 14 )  volume_flow_initial
     WRITE ( 14 )  'wall_adjustment               '
     WRITE ( 14 )  wall_adjustment
@@ -437,7 +445,4 @@
     WRITE ( 14 )  'w_max_ijk                     '
     WRITE ( 14 )  w_max_ijk
-    WRITE ( 14 )  'time-series-quantities        '
-    WRITE ( 14 )  cross_ts_uymax, cross_ts_uymax_computed, cross_ts_uymin, &
-                  cross_ts_uymin_computed
 
 !