Index: palm/trunk/DOC/app/chapter_3.7.html
===================================================================
--- palm/trunk/DOC/app/chapter_3.7.html	(revision 61)
+++ palm/trunk/DOC/app/chapter_3.7.html	(revision 148)
@@ -1,12 +1,29 @@
 <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
-<html><head>
-<meta http-equiv="CONTENT-TYPE" content="text/html; charset=windows-1252"><title>PALM
-chapter 3.7</title> <meta name="GENERATOR" content="StarOffice 7 (Win32)"> <meta name="AUTHOR" content="Siegfried Raasch"> <meta name="CREATED" content="20040809;13460943"> <meta name="CHANGED" content="20041112;15085727"> <meta name="KEYWORDS" content="parallel LES model"> <style>
+<html>
+<head>
+
+  <meta http-equiv="CONTENT-TYPE" content="text/html; charset=windows-1252">
+  <title>PALM chapter 3.7</title>
+ 
+  <meta name="GENERATOR" content="StarOffice 7 (Win32)">
+ 
+  <meta name="AUTHOR" content="Siegfried Raasch">
+ 
+  <meta name="CREATED" content="20040809;13460943">
+ 
+  <meta name="CHANGED" content="20041112;15085727">
+ 
+  <meta name="KEYWORDS" content="parallel LES model">
+ 
+  <style>
 <!--
 @page { size: 21cm 29.7cm }
 -->
-</style></head>
+  </style>
+</head>
 
-<body style="direction: ltr;" lang="en-US"><h3 style="line-height: 100%;">3.7 Optional software packages</h3>
+<body style="direction: ltr;" lang="en-US">
+<h3 style="line-height: 100%;">3.7 Optional software packages</h3>
+
 <p style="line-height: 100%;">Starting from version 2.1
 PALM includes
@@ -19,4 +36,5 @@
 compilation time as well as the memory demand of the model is limited
 to the real needs. </p>
+
 <p style="line-height: 100%;">To use software packages in
 a model run,
@@ -31,7 +49,13 @@
 the <b>mrun</b> call
 has to be: </p>
-<ul> <p style="line-height: 100%;"><tt><font style="font-size: 10pt;" size="2">mrun ... -p
+
+<ul>
+ 
+  <p style="line-height: 100%;"><tt><font style="font-size: 10pt;" size="2">mrun ... -p
 &ldquo;package1 package2&rdquo; </font>.</tt></p>
-</ul><p style="line-height: 100%;">Starting from version 3.2, the particles-package is part of the default model, so it does not have to be switched on using <span style="font-weight: bold;">mrun</span>-option <span style="font-family: Courier New,Courier,monospace;">-p</span>. However, the respective parameters have still to be set by using the NAMELIST group <span style="font-family: Courier New,Courier,monospace;">particles_par</span>.</p><p style="line-height: 100%;">Further package
+
+</ul>
+<p style="line-height: 100%;">Starting from version 3.2, the particles-package is part of the default model, so it does not have to be switched on using <span style="font-weight: bold;">mrun</span>-option <span style="font-family: Courier New,Courier,monospace;">-p</span>. However, the respective parameters have still to be set by using the NAMELIST group <span style="font-family: Courier New,Courier,monospace;">particles_par</span>.</p>
+<p style="line-height: 100%;">Further package
 names can be added to
 the list, separated by blanks. If the respective packages permit user
@@ -43,41 +67,113 @@
 group name is given in the table below. For the example above one
 would have to add the following lines to PARIN (example): &nbsp; </p>
-<ul> <p style="line-height: 100%;"><tt><font style="font-size: 10pt;" size="2">&amp;namelist_packagename1
+
+<ul>
+ 
+  <p style="line-height: 100%;"><tt><font style="font-size: 10pt;" size="2">&amp;namelist_packagename1
 var1 = 1,0, var2 =
 &ldquo;abcd&rdquo; /</font></tt><font style="font-size: 10pt;" size="2"> </font> </p>
-<p style="line-height: 100%;"><tt><font style="font-size: 10pt;" size="2">&amp;namelist_packagename2
+
+  <p style="line-height: 100%;"><tt><font style="font-size: 10pt;" size="2">&amp;namelist_packagename2
 var3 = .TRUE.,
 var4 = 0 /</font></tt></p>
-</ul><p style="margin-bottom: 0cm; line-height: 100%;">The
+
+</ul>
+<p style="margin-bottom: 0cm; line-height: 100%;">The
 following
 packages are available: <br>
+
 &nbsp; <br>
+
 &nbsp; </p>
-<table border="1" cellpadding="2" cellspacing="2" width="100%"> <tbody> <tr> <td> <p><b>Package
-name:</b></p> </td> <td> <p><b>NAMELIST
-group name:</b></p> </td> <td> <p><b>Functionality:</b></p>
-</td> <td> <p><b>Control parameter:</b></p>
-</td> </tr> <tr valign="top"> <td> <p>--- (see above)</p>
-</td> <td> <p>particles_par</p> </td> <td>
-<p>Release and advection of particles. The particle sources can
+
+<table border="1" cellpadding="2" cellspacing="2" width="100%">
+ <tbody>
+ <tr>
+ <td> 
+      <p><b>Package
+name:</b></p>
+ </td>
+ <td> 
+      <p><b>NAMELIST
+group name:</b></p>
+ </td>
+ <td> 
+      <p><b>Functionality:</b></p>
+
+      </td>
+ <td> 
+      <p><b>Control parameter:</b></p>
+
+      </td>
+ </tr>
+ <tr valign="top">
+ <td> 
+      <p>--- (see above)</p>
+
+      </td>
+ <td> 
+      <p>particles_par</p>
+ </td>
+ <td>
+      <p>Release and advection of particles. The particle sources can
 additionally be defined by the user in subroutine <tt><font style="font-size: 10pt;" size="2">user_init_particles</font></tt>
-.</p> </td> <td> <p>see section 4.2</p>
-</td> </tr> <tr valign="top"> <td> <p>dvrp_graphics</p>
-</td> <td> <p>dvrp_graphics_par</p> </td>
-<td> <p>Graphical output with the dvrp software of the
+.</p>
+ </td>
+ <td> 
+      <p>see section 4.2</p>
+
+      </td>
+ </tr>
+ <tr valign="top">
+ <td> 
+      <p>dvrp_graphics</p>
+
+      </td>
+ <td> 
+      <p>dvrp_graphics_par</p>
+ </td>
+
+      <td> 
+      <p>Graphical output with the dvrp software of the
 RRZN. This is
 only available on the IBM Regatta "hanni" of the HLRN. Possible output
 are iso-surfaces, cross-sections and particles (if the particle package
-is selected). The use of this package is described in section <a href="chapter_4.5.7.html">4.5.7</a>.</p> </td>
-<td> <p>see section 4.2</p> </td> </tr>
-<tr valign="top"> <td> <p>spectra</p> </td>
-<td> <p>spectra_par</p> </td> <td> <p>Computation
+is selected). The use of this package is described in section <a href="chapter_4.5.7.html">4.5.7</a>.</p>
+ </td>
+
+      <td> 
+      <p>see section 4.2</p>
+ </td>
+ </tr>
+
+    <tr valign="top">
+ <td> 
+      <p>spectra</p>
+ </td>
+
+      <td> 
+      <p>spectra_par</p>
+ </td>
+ <td> 
+      <p>Computation
 and output of horizontal power spectra of the
-prognostic variables. </p> </td> <td> <p>see
+prognostic variables. </p>
+ </td>
+ <td> 
+      <p>see
 section <a href="chapter_4.2.html#spectra_package">4.2</a></p>
-</td> </tr> </tbody>
-</table><hr>
-<p style="line-height: 100%;"><br><font color="#000080"><font color="#000080"><a href="chapter_3.6.html"><font color="#000080"><img src="left.gif" name="Grafik1" align="bottom" border="2" height="32" width="32"></font></a><a href="index.html"><font color="#000080"><img src="up.gif" name="Grafik2" align="bottom" border="2" height="32" width="32"></font></a><a href="chapter_4.0.html"><font color="#000080"><img src="right.gif" name="Grafik3" align="bottom" border="2" height="32" width="32"></font></a></font></font></p>
+
+      </td>
+ </tr>
+ 
+  </tbody>
+</table>
+<hr>
+<p style="line-height: 100%;"><br>
+<font color="#000080"><font color="#000080"><a href="chapter_3.6.html"><font color="#000080"><img src="left.gif" name="Grafik1" align="bottom" border="2" height="32" width="32"></font></a><a href="index.html"><font color="#000080"><img src="up.gif" name="Grafik2" align="bottom" border="2" height="32" width="32"></font></a><a href="chapter_3.8.html"><font color="#000080"><img style="border: 2px solid ; width: 32px; height: 32px;" alt="" src="right.gif" name="Grafik3"></font></a></font></font></p>
+
 <p style="line-height: 100%;"><i>Last
 change:&nbsp;</i> $Id$</p>
-</body></html>
+
+</body>
+</html>