Index: palm/trunk/SOURCE/CURRENT_MODIFICATIONS
===================================================================
--- palm/trunk/SOURCE/CURRENT_MODIFICATIONS	(revision 154)
+++ palm/trunk/SOURCE/CURRENT_MODIFICATIONS	(revision 155)
@@ -22,5 +22,4 @@
 
 Particle advection adjusted for ocean runs.
-
 
 User-defined spectra.
@@ -54,4 +53,5 @@
 Errors:
 ------
+Introduce prefix_chr to ensure unique dvrp_file path.
 small bugfixes for user_interface sample code (comments):
 - initialize ustvst with 0.0 as it is now computed only until nxr and nyn
@@ -69,4 +69,4 @@
 
 
-flow_statistics, local_stop, plant_canopy_model, pres, read_3d_binary, user_interface, write_3d_binary
+flow_statistics, init_dvrp, local_stop, plant_canopy_model, pres, read_3d_binary, user_interface, write_3d_binary
 
Index: palm/trunk/SOURCE/init_dvrp.f90
===================================================================
--- palm/trunk/SOURCE/init_dvrp.f90	(revision 154)
+++ palm/trunk/SOURCE/init_dvrp.f90	(revision 155)
@@ -5,4 +5,5 @@
 ! -----------------
 ! 
+! introduce prefix_chr to ensure unique dvrp_file path
 ! TEST: print* statements
 ! ToDo: checking of mode_dvrp for legal values is not correct
@@ -50,4 +51,5 @@
 
     CHARACTER (LEN=2)  ::  section_chr
+    CHARACTER (LEN=3)  ::  prefix_chr
     CHARACTER (LEN=80) ::  dvrp_file_local
     INTEGER ::  i, j, k, l, m, pn, tv, vn
@@ -130,5 +132,7 @@
 
        ENDIF
-    
+!
+!--    Determine prefix for dvrp_file
+       WRITE ( prefix_chr, '(I2.2,''_'')' )  m
 !
 !--    Camera position must be computed and written on file when no dvrp-output
@@ -155,5 +159,5 @@
     CALL local_flush( 9 )
 
-             dvrp_file   = TRIM( mode_dvrp(m) ) // '/camera.dvr'
+             dvrp_file   = prefix_chr // TRIM( mode_dvrp(m) ) // '/camera.dvr'
              dvrp_file_c = dvrp_file
              CALL DVRP_OUTPUT_RTSP( m-1, dvrp_host_c, dvrp_username_c, &
@@ -165,5 +169,5 @@
           ELSEIF ( dvrp_output == 'ftp' )  THEN
 
-             dvrp_file   = TRIM( mode_dvrp(m) ) // '.camera.dvr'
+             dvrp_file   = prefix_chr // TRIM( mode_dvrp(m) ) // '.camera.dvr'
              dvrp_file_c = dvrp_file
 !             CALL DVRP_OUTPUT_FTP( m-1, 0, dvrp_host_c, dvrp_username_c, &
@@ -174,5 +178,6 @@
 
              IF ( dvrp_file(1:9) /= '/dev/null' )  THEN
-                dvrp_file_local   = TRIM( mode_dvrp(m) ) // '.camera.dvr'
+                dvrp_file_local   = prefix_chr // TRIM( mode_dvrp(m) )  &
+                     // '.camera.dvr'
                 dvrp_file_local_c = dvrp_file_local
              ELSE
@@ -209,5 +214,6 @@
           IF ( dvrp_output == 'rtsp' )  THEN
 
-             dvrp_file   = TRIM( mode_dvrp(m) ) // '/buildings.dvr'
+             dvrp_file   = prefix_chr // TRIM( mode_dvrp(m) )  &
+                  // '/buildings.dvr'
              dvrp_file_c = dvrp_file
              CALL DVRP_OUTPUT_RTSP( m-1, dvrp_host_c, dvrp_username_c, &
@@ -219,5 +225,6 @@
           ELSEIF ( dvrp_output == 'ftp' )  THEN
 
-             dvrp_file   = TRIM( mode_dvrp(m) ) // '.buildings.dvr'
+             dvrp_file   = prefix_chr // TRIM( mode_dvrp(m) )  &
+                  // '.buildings.dvr'
              dvrp_file_c = dvrp_file
 !             CALL DVRP_OUTPUT_FTP( m-1, 0, dvrp_host_c, dvrp_username_c, &
@@ -228,5 +235,6 @@
 
              IF ( dvrp_file(1:9) /= '/dev/null' )  THEN
-                dvrp_file_local   = TRIM( mode_dvrp(m) ) // '.buildings.dvr'
+                dvrp_file_local   = prefix_chr // TRIM( mode_dvrp(m) )  &
+                     // '.buildings.dvr'
                 dvrp_file_local_c = dvrp_file_local
              ELSE
@@ -302,5 +310,5 @@
           IF ( dvrp_output == 'rtsp' )  THEN
 
-             dvrp_file   = TRIM( mode_dvrp(m) ) // '/surface.dvr'
+             dvrp_file   = prefix_chr // TRIM( mode_dvrp(m) ) // '/surface.dvr'
              dvrp_file_c = dvrp_file
              CALL DVRP_OUTPUT_RTSP( m-1, dvrp_host_c, dvrp_username_c, &
@@ -312,5 +320,5 @@
           ELSEIF ( dvrp_output == 'ftp' )  THEN
 
-             dvrp_file   = TRIM( mode_dvrp(m) ) // '.surface.dvr'
+             dvrp_file   = prefix_chr // TRIM( mode_dvrp(m) ) // '.surface.dvr'
              dvrp_file_c = dvrp_file
 !             CALL DVRP_OUTPUT_FTP( m-1, 0, dvrp_host_c, dvrp_username_c, &
@@ -321,5 +329,6 @@
 
              IF ( dvrp_file(1:9) /= '/dev/null' )  THEN
-                dvrp_file_local   = TRIM( mode_dvrp(m) ) // '.surface.dvr'
+                dvrp_file_local   = prefix_chr // TRIM( mode_dvrp(m) )  &
+                     // '.surface.dvr'
                 dvrp_file_local_c = dvrp_file_local
              ELSE
@@ -463,5 +472,5 @@
     CALL local_flush( 9 )
 
-          dvrp_file = TRIM( mode_dvrp(m) ) // '/*****.dvr'
+          dvrp_file = prefix_chr // TRIM( mode_dvrp(m) ) // '/*****.dvr'
           dvrp_file_c = dvrp_file
           CALL DVRP_OUTPUT_RTSP( m-1, dvrp_host_c, dvrp_username_c, &
@@ -473,5 +482,5 @@
        ELSEIF ( dvrp_output == 'ftp' )  THEN
 
-          dvrp_file   = TRIM( mode_dvrp(m) ) // '.%05d.dvr'
+          dvrp_file   = prefix_chr // TRIM( mode_dvrp(m) ) // '.%05d.dvr'
           dvrp_file_c = dvrp_file
 !          CALL DVRP_OUTPUT_FTP( m-1, 0, dvrp_host_c, dvrp_username_c, &
@@ -481,5 +490,6 @@
 
           IF ( dvrp_file(1:9) /= '/dev/null' )  THEN
-             dvrp_file_local   = TRIM( mode_dvrp(m) ) // '_%05d.dvr'
+             dvrp_file_local   = prefix_chr // TRIM( mode_dvrp(m) )  &
+                  // '_%05d.dvr'
              dvrp_file_local_c = dvrp_file_local
           ELSE
@@ -490,6 +500,8 @@
        ENDIF
 
-!       dvrp_file = TRIM( mode_dvrp(m) ) // '.%05d.dvr' // CHAR( 0 )
-!       dvrp_file = TRIM( mode_dvrp(m) ) // '/*****.dvr' // CHAR( 0 )
+!       dvrp_file = prefix_chr // TRIM( mode_dvrp(m) ) // '.%05d.dvr'  &
+!                   // CHAR( 0 )
+!       dvrp_file = prefix_chr // TRIM( mode_dvrp(m) ) // '/*****.dvr'  &
+!                   // CHAR( 0 )
 !       dvrp_file = '/dev/null' // CHAR( 0 )
 !       CALL DVRP_OUTPUT_FTP( m-1, 0, dvrp_host, dvrp_username, dvrp_password, &