Index: palm/trunk/DOC/app/chapter_4.1.html
===================================================================
--- palm/trunk/DOC/app/chapter_4.1.html	(revision 153)
+++ palm/trunk/DOC/app/chapter_4.1.html	(revision 160)
@@ -1,5 +1,4 @@
 <!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
-<html>
-<head>
+<html><head>
 
 
@@ -28,7 +27,5 @@
   
   
-  <title>PALM chapter 4.1</title>
-</head>
-
+  <title>PALM chapter 4.1</title></head>
 
 <body>
@@ -2792,11 +2789,11 @@
  <tr>
 
-      <td><a name="canopy_mode"></a><span style="font-weight: bold;">canopy_mode</span></td>
-
-      <td>C * 20</td>
-
-      <td><span style="font-style: italic;">'block'</span></td>
-
-      <td>Canopy mode.<br>
+      <td style="vertical-align: top;"><a name="canopy_mode"></a><span style="font-weight: bold;">canopy_mode</span></td>
+
+      <td style="vertical-align: top;">C * 20</td>
+
+      <td style="vertical-align: top;"><span style="font-style: italic;">'block'</span></td>
+
+      <td style="vertical-align: top;">Canopy mode.<br>
 
       <br>
@@ -3149,11 +3146,11 @@
  <tr>
 
-      <td><a name="cthf"></a><span style="font-weight: bold;">cthf</span></td>
-
-      <td>R</td>
-
-      <td><span style="font-style: italic;">0.0</span></td>
-
-      <td>Average heat flux that is prescribed at the top of the plant canopy.<br>
+      <td style="vertical-align: top;"><a name="cthf"></a><span style="font-weight: bold;">cthf</span></td>
+
+      <td style="vertical-align: top;">R</td>
+
+      <td style="vertical-align: top;"><span style="font-style: italic;">0.0</span></td>
+
+      <td style="vertical-align: top;">Average heat flux that is prescribed at the top of the plant canopy.<br>
 
 
@@ -3532,11 +3529,11 @@
     <tr>
 
-      <td><a name="drag_coefficient"></a><span style="font-weight: bold;">drag_coefficient</span></td>
-
-      <td>R</td>
-
-      <td><span style="font-style: italic;">0.0</span></td>
-
-      <td>Drag coefficient used in the plant canopy model.<br>
+      <td style="vertical-align: top;"><a name="drag_coefficient"></a><span style="font-weight: bold;">drag_coefficient</span></td>
+
+      <td style="vertical-align: top;">R</td>
+
+      <td style="vertical-align: top;"><span style="font-style: italic;">0.0</span></td>
+
+      <td style="vertical-align: top;">Drag coefficient used in the plant canopy model.<br>
 
       <br>
@@ -6324,11 +6321,11 @@
  <tr>
 
-      <td><a name="lad_surface"></a><span style="font-weight: bold;">lad_surface</span></td>
-
-      <td>R</td>
-
-      <td><span style="font-style: italic;">0.0</span></td>
-
-      <td>Surface value of the leaf area density (in m<sup>2</sup>/m<sup>3</sup>).<br>
+      <td style="vertical-align: top;"><a name="lad_surface"></a><span style="font-weight: bold;">lad_surface</span></td>
+
+      <td style="vertical-align: top;">R</td>
+
+      <td style="vertical-align: top;"><span style="font-style: italic;">0.0</span></td>
+
+      <td style="vertical-align: top;">Surface value of the leaf area density (in m<sup>2</sup>/m<sup>3</sup>).<br>
 
       <br>
@@ -6344,11 +6341,11 @@
     <tr>
 
-      <td><a name="lad_vertical_gradient"></a><span style="font-weight: bold;">lad_vertical_gradient</span></td>
-
-      <td>R (10)</td>
-
-      <td><span style="font-style: italic;">10 * 0.0</span></td>
-
-      <td>Gradient(s) of the leaf area density (in&nbsp;m<sup>2</sup>/m<sup>4</sup>).<br>
+      <td style="vertical-align: top;"><a name="lad_vertical_gradient"></a><span style="font-weight: bold;">lad_vertical_gradient</span></td>
+
+      <td style="vertical-align: top;">R (10)</td>
+
+      <td style="vertical-align: top;"><span style="font-style: italic;">10 * 0.0</span></td>
+
+      <td style="vertical-align: top;">Gradient(s) of the leaf area density (in&nbsp;m<sup>2</sup>/m<sup>4</sup>).<br>
 
       <br>
@@ -6371,11 +6368,11 @@
     <tr>
 
-      <td><a name="lad_vertical_gradient_level"></a><span style="font-weight: bold;">lad_vertical_gradient_level</span></td>
-
-      <td>R (10)</td>
-
-      <td><span style="font-style: italic;">10 * 0.0</span></td>
-
-      <td>Height level from which on the&nbsp;gradient
+      <td style="vertical-align: top;"><a name="lad_vertical_gradient_level"></a><span style="font-weight: bold;">lad_vertical_gradient_level</span></td>
+
+      <td style="vertical-align: top;">R (10)</td>
+
+      <td style="vertical-align: top;"><span style="font-style: italic;">10 * 0.0</span></td>
+
+      <td style="vertical-align: top;">Height level from which on the&nbsp;gradient
 of the leaf area density defined by <a href="chapter_4.1.html#lad_vertical_gradient">lad_vertical_gradient_level</a>
 is effective (in m).<br>
@@ -6390,11 +6387,11 @@
     <tr>
 
-      <td><a name="leaf_surface_concentration"></a><b>leaf_surface_concentration</b></td>
-
-      <td>R</td>
-
-      <td><i>0.0</i></td>
-
-      <td>Concentration of a passive scalar at the surface of a leaf (in K m/s).<br>
+      <td style="vertical-align: top;"><a name="leaf_surface_concentration"></a><b>leaf_surface_concentration</b></td>
+
+      <td style="vertical-align: top;">R</td>
+
+      <td style="vertical-align: top;"><i>0.0</i></td>
+
+      <td style="vertical-align: top;">Concentration of a passive scalar at the surface of a leaf (in K m/s).<br>
 
 
@@ -9631,11 +9628,11 @@
  <tr>
 
-      <td><a name="pch_index"></a><span style="font-weight: bold;">pch_index</span></td>
-
-      <td>I</td>
-
-      <td><span style="font-style: italic;">0</span></td>
-
-      <td>Grid point index (scalar) of the upper boundary of the plant canopy layer.<br>
+      <td style="vertical-align: top;"><a name="pch_index"></a><span style="font-weight: bold;">pch_index</span></td>
+
+      <td style="vertical-align: top;">I</td>
+
+      <td style="vertical-align: top;"><span style="font-style: italic;">0</span></td>
+
+      <td style="vertical-align: top;">Grid point index (scalar) of the upper boundary of the plant canopy layer.<br>
 
       <br>
@@ -9738,11 +9735,11 @@
  <tr>
 
-      <td><a name="plant_canopy"></a><span style="font-weight: bold;">plant_canopy</span></td>
-
-      <td>L</td>
-
-      <td><span style="font-style: italic;">.F.</span></td>
-
-      <td>Switch for the plant_canopy_model.<br>
+      <td style="vertical-align: top;"><a name="plant_canopy"></a><span style="font-weight: bold;">plant_canopy</span></td>
+
+      <td style="vertical-align: top;">L</td>
+
+      <td style="vertical-align: top;"><span style="font-style: italic;">.F.</span></td>
+
+      <td style="vertical-align: top;">Switch for the plant_canopy_model.<br>
 
       <br>
@@ -12520,11 +12517,11 @@
  <tr>
 
-      <td><a name="scalar_exchange_coefficient"></a><b>scalar_exchange_coefficient</b></td>
-
-      <td>R</td>
-
-      <td><span style="font-style: italic;">0.0</span></td>
-
-      <td>Scalar exchange coefficient for a leaf (dimensionless).<br>
+      <td style="vertical-align: top;"><a name="scalar_exchange_coefficient"></a><b>scalar_exchange_coefficient</b></td>
+
+      <td style="vertical-align: top;">R</td>
+
+      <td style="vertical-align: top;"><span style="font-style: italic;">0.0</span></td>
+
+      <td style="vertical-align: top;">Scalar exchange coefficient for a leaf (dimensionless).<br>
 
 
@@ -17030,4 +17027,3 @@
 
 
-</body>
-</html>
+</body></html>